org.springframework.beans.factory.config

## Class MethodInvokingFactoryBean

- java.lang.Object
- - org.springframework.util.MethodInvoker
  - - org.springframework.beans.support.ArgumentConvertingMethodInvoker
    - - org.springframework.beans.factory.config.MethodInvokingBean
      - - org.springframework.beans.factory.config.MethodInvokingFactoryBean

- All Implemented Interfaces:
    Aware, BeanClassLoaderAware, BeanFactoryAware, FactoryBean<Object>, InitializingBean

      public class MethodInvokingFactoryBean
      extends MethodInvokingBean
      implements FactoryBean<Object>

  `FactoryBean` which returns a value which is the result of a static or instance method invocation. For most use cases it is better to just use the container's built-in factory method support for the same purpose, since that is smarter at converting arguments. This factory bean is still useful though when you need to call a method which doesn't return any value (for example, a static class method to force some sort of initialization to happen). This use case is not supported by factory methods, since a return value is needed to obtain the bean instance.

  Note that as it is expected to be used mostly for accessing factory methods, this factory by default operates in a singleton fashion. The first request to `getObject()` by the owning bean factory will cause a method invocation, whose return value will be cached for subsequent requests. An internal `singleton` property may be set to "false", to cause this factory to invoke the target method each time it is asked for an object.

  NOTE: If your target method does not produce a result to expose, consider `MethodInvokingBean` instead, which avoids the type determination and lifecycle limitations that this `MethodInvokingFactoryBean` comes with.

  This invoker supports any kind of target method. A static method may be specified by setting the `targetMethod` property to a String representing the static method name, with `targetClass` specifying the Class that the static method is defined on. Alternatively, a target instance method may be specified, by setting the `targetObject` property as the target object, and the `targetMethod` property as the name of the method to call on that target object. Arguments for the method invocation may be specified by setting the `arguments` property.

  This class depends on `afterPropertiesSet()` being called once all properties have been set, as per the InitializingBean contract.

  An example (in an XML based bean factory definition) of a bean definition which uses this class to call a static factory method:

       <bean id="myObject" class="org.springframework.beans.factory.config.MethodInvokingFactoryBean">
         <property name="staticMethod" value="com.whatever.MyClassFactory.getInstance"/>
       </bean>

  An example of calling a static method then an instance method to get at a Java system property. Somewhat verbose, but it works.

       <bean id="sysProps" class="org.springframework.beans.factory.config.MethodInvokingFactoryBean">
         <property name="targetClass" value="java.lang.System"/>
         <property name="targetMethod" value="getProperties"/>
       </bean>

       <bean id="javaVersion" class="org.springframework.beans.factory.config.MethodInvokingFactoryBean">
         <property name="targetObject" value="sysProps"/>
         <property name="targetMethod" value="getProperty"/>
         <property name="arguments" value="java.version"/>
       </bean>

  Since:
    21.11.2003
  Author:
    Colin Sampaleanu, Juergen Hoeller
  See Also:
    `MethodInvokingBean`, `MethodInvoker`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `MethodInvokingFactoryBean()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
    `Object` | `getObject()` Returns the same value each time if the singleton property is set to "true", otherwise returns the value returned from invoking the specified method on the fly.
    `Class<?>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
    `boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
    `void` | `setSingleton(boolean singleton)` Set if a singleton should be created, or a new object on each `getObject()` request otherwise.

    - ### Methods inherited from class org.springframework.beans.factory.config.MethodInvokingBean

      `getDefaultTypeConverter, invokeWithTargetException, resolveClassName, setBeanClassLoader, setBeanFactory`

    - ### Methods inherited from class org.springframework.beans.support.ArgumentConvertingMethodInvoker

      `doFindMatchingMethod, findMatchingMethod, getTypeConverter, registerCustomEditor, setTypeConverter`

    - ### Methods inherited from class org.springframework.util.MethodInvoker

      `getArguments, getPreparedMethod, getTargetClass, getTargetMethod, getTargetObject, getTypeDifferenceWeight, invoke, isPrepared, prepare, setArguments, setStaticMethod, setTargetClass, setTargetMethod, setTargetObject`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### MethodInvokingFactoryBean

          public MethodInvokingFactoryBean()

  - ### Method Detail

    - #### setSingleton

          public void setSingleton(boolean singleton)

      Set if a singleton should be created, or a new object on each `getObject()` request otherwise. Default is "true".

    - #### afterPropertiesSet

          public void afterPropertiesSet()
                                  throws Exception

      Description copied from interface: `InitializingBean`
      Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

      This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

      Specified by:
        `afterPropertiesSet` in interface `InitializingBean`
      Overrides:
        `afterPropertiesSet` in class `MethodInvokingBean`
      Throws:
        `Exception` - in the event of misconfiguration (such as failure to set an essential property) or if initialization fails.

    - #### getObject

          public Object getObject()
                           throws Exception

      Returns the same value each time if the singleton property is set to "true", otherwise returns the value returned from invoking the specified method on the fly.
      Specified by:
        `getObject` in interface `FactoryBean<Object>`
      Returns:
        an instance of the bean (can be `null`)
      Throws:
        `Exception` - in case of creation errors
      See Also:
        `FactoryBeanNotInitializedException`

    - #### getObjectType

          public Class<?> getObjectType()

      Return the type of object that this FactoryBean creates, or `null` if not known in advance.
      Specified by:
        `getObjectType` in interface `FactoryBean<Object>`
      Returns:
        the type of object that this FactoryBean creates, or `null` if not known at the time of the call
      See Also:
        `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

    - #### isSingleton

          public boolean isSingleton()

      Description copied from interface: `FactoryBean`
      Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

      NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

      The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

      NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

      Specified by:
        `isSingleton` in interface `FactoryBean<Object>`
      Returns:
        whether the exposed object is a singleton
      See Also:
        `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`